unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, ADODB_TLB, clipbrd, Registry, 
  OLEDB, AdoDB, ComObj, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    btnOpenDialog: TButton;
    ADOConnectionString: TEdit;
    Label1: TLabel;
    procedure btnOpenDialogClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

function PromptDataSource(ParentHandle: THandle; InitialString: WideString): WideString;
var
  DataInit: IDataInitialize;
  DBPrompt: IDBPromptInitialize;
  DataSource: IUnknown;
  InitStr: PWideChar;
begin
  Result := InitialString;
  DataInit := CreateComObject(CLSID_DataLinks) as IDataInitialize;
  if InitialString <> '' then
    DataInit.GetDataSource(nil, CLSCTX_INPROC_SERVER,
      PWideChar(InitialString), IUnknown, DataSource);
  DBPrompt := CreateComObject(CLSID_DataLinks) as IDBPromptInitialize;
  if Succeeded(DBPrompt.PromptDataSource(nil, ParentHandle,
    DBPROMPTOPTIONS_PROPERTYSHEET, 0, nil, nil, IUnknown, DataSource)) then
  begin
    InitStr := nil;
    DataInit.GetInitializationString(DataSource, True, InitStr);
    Result := InitStr;
  end;
end;

procedure TForm1.btnOpenDialogClick(Sender: TObject);
Var
  ConnectionString : String;
begin
  ConnectionString  := PromptDataSource(Handle, ADOConnectionString.text);
  if (ConnectionString <>'') then
    begin
     ADOConnectionString.text := ConnectionString;
     ADOConnectionString.SelectAll;
     clipboard.AsText :=       ADOConnectionString.text
    end;
end;


end.

